﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=StaticCode
Version=7
@EndOfDesignText@
'Static code module
Sub Process_Globals
	Private banano As BANano
	Public PhpPath As String = $"http://127.0.0.1/AJAX/assets/"$
	Public BANanano As BANano
End Sub

Sub Init()
	banano.GetElement("#body").Empty
	banano.GetElement("#body").Append($"<input id="txtusername" type="text" placeholder="User Name"></input><br><br>"$)
	banano.GetElement("#body").Append($"<input id="txtpassword" type="password" placeholder="Password"></input><br><br>"$)
	banano.GetElement("#body").Append($"<button id="btnlogin">LOGIN</button><br><br>"$)
	banano.GetElement("#body").Append($"<button id="btnloginw">LOGIN WAIT</button><br><br>"$)
	banano.GetElement("#body").Append($"<button id="btnregister">REGISTER</button><br><br>"$)
	banano.GetElement("#body").Append($"<button id="btngetall">GET ALL (WAIT)</button><br><br><br>"$)
	banano.GetElement("#body").Append($"<table id="users"></table>"$)
	
	banano.GetElement("#btnlogin").On("click", Me, "login")
	banano.GetElement("#btnloginw").On("click", Me, "loginw")
	banano.GetElement("#btnregister").On("click", Me, "register")
	banano.GetElement("#btngetall").On("click", Me, "getall")
End Sub

Sub getall(e As BANanoEvent)
	If banano.CheckInternetConnectionWait Then
		Dim dbAction As Map = CreateMap("action":"getall")
		'build the php
		Dim m As Map = BuildPHP(dbAction,"users.php")
		Dim headers As Map = m.Get("headers")
		Dim sCommand As String = m.Get("command")
		'execute the php
		Dim result As String = banano.CallAjaxWait(sCommand, "GET", "json","",False, headers)
		'convert the json string to a list, the list already contains map records for each user
		Dim res As List = Json2List(result)
		ShowReport(res)
	End If
End Sub

#if css
	table {width: 100%;border: 1px solid #cef;text-align: left; }
	th { font-weight: bold;	background-color: #acf;	border-bottom: 1px solid #cef; } 
	td,th {	padding: 4px 5px; }
	.odd {background-color: #def; } 
	.odd td {border-bottom: 1px solid #cef; }
	a { text-decoration:none; color: #000;}
#End If

'generate a webview of the records
Sub ShowReport(res As List)
	'load the report layout
	'lets build the report
	Dim sb As StringBuilder
	sb.Initialize
	'define the table and heading
	sb.Append($"<table id="users"><thead><tr>"$).Append(CRLF)
	'lets get the first record from to determine the fields
	'get the records, its json
	Dim recm As Map = res.Get(0)
	'define a list to store column names
	Dim cols As List
	cols.Initialize
	For Each strKey As String In recm.Keys
		cols.Add(strKey)
	Next
	'create each column as table heading
	For i = 0 To cols.Size - 1
		sb.Append("<th>").Append(cols.get(i)).Append("</th>")
	Next
	sb.Append("</thead>")
	sb.Append("</tr>").Append(CRLF)
	Dim row As Int
	'add the column data per record
	For Each recm As Map In res
		If row Mod 2 = 0 Then
			sb.Append("<tr>")
		Else
			sb.Append("<tr class='odd'>")
		End If
		For i = 0 To cols.Size - 1
			sb.Append("<td>")
			Dim colName As String = cols.Get(i)
			Dim colValue As String = recm.GetDefault(colName,"")
			sb.Append(colValue)
			sb.Append("</td>")
		Next
		sb.Append("</tr>").Append(CRLF)
		row = row + 1
	Next
	sb.Append("</table></body></html>")
	banano.GetElement("#users").Replace(sb.ToString)
	'banano.GetElement("#users").SetStyle($"{"width": "100%", "border": "1px solid #cef", "text-align": "left"}"$)
	'SetStyle("th",CreateMap("font-weight": "bold", "background-color": "#acf",	"border-bottom": "1px solid #cef"))
	'SetStyle("td,th", CreateMap("padding": "4px 5px"))
End Sub

Sub SetStyle(elID As String, styleMap As Map)
	Dim strStyle As String = Map2Json(styleMap)
	banano.GetElement(elID).SetStyle(strStyle)
End Sub


'convert a map to a json string
Sub Map2Json(mp As Map) As String
	Dim JSON As BANanoJSONGenerator
	JSON.Initialize(mp)
	Return JSON.ToString
End Sub


Sub register(e As BANanoEvent)
	If banano.CheckInternetConnectionWait Then
		Dim strUser As String = banano.GetElement("#txtusername").GetValue
		'build php query
		Dim straction As String = "checkusername"
		Dim dbAction As Map
		dbAction.Initialize
		dbAction.Put("action=", straction)
		dbAction.Put("username=", strUser)
		'execute php
		ExecutePHP(dbAction,"users.php",straction)
	End If
End Sub

Sub login(e As BANanoEvent)
	If banano.CheckInternetConnectionWait Then
		Dim strUser As String = banano.GetElement("#txtusername").GetValue
		Dim strPwd As String = banano.GetElement("#txtpassword").GetValue
		'build php query
		Dim straction As String = "validateuser"
		Dim dbAction As Map
		dbAction.Initialize
		dbAction.Put("action=", straction)
		dbAction.Put("username=", strUser)
		dbAction.Put("userpassword=", strPwd)
		'execute php
		ExecutePHP(dbAction,"users.php",straction)
	End If
End Sub

Sub ExecutePHP(pQuery As Map, phpFile As String, phpTag As String)
	Dim json As String
	Dim sCommand As String = ""
	json = Map2QueryString(pQuery)
	If Len(json) = 0 Then
		sCommand = $"${PhpPath}${phpFile}"$
	Else
		sCommand = $"${PhpPath}${phpFile}?${json}"$
	End If
	'create the headers
	Dim headers As Map
	headers.Initialize
	headers.put("Content-Type", "application/json")
	headers.Put("Access-Control-Allow-Origin", "*")
	banano.CallAjax(sCommand, "GET", "json","",phpTag,False, headers)
End Sub


Sub BANano_CallAjaxResult(Success As Boolean, UniqueID As String, Result As String)
	If Success Then
		'convert ths json result to a list
		Dim res As List = Json2List(Result)
		Select Case UniqueID
		Case "validateuser"
			If res.Size = 0 Then
				'user not validated
				banano.Msgbox("The user credentials could not be validated!")
			Else
				banano.Msgbox("Go on, show another screen...")
			End If
		Case "checkusername"
			If res.Size = 0 Then
				' this username does not exist
				RegisterUser
			Else
				' this username exists
				banano.Msgbox("A user with the specified username already exists!")
				End If
		Case "registeruser"
			If res.Size = 0 Then
				banano.Msgbox("User could not be registered successfully, please try again!")
			Else
				banano.Msgbox("User was successfully registered!")
			End If
		End Select
	End If
End Sub


'convert a json string to a map
Sub Json2Map(strJSON As String) As Map
	Dim json As BANanoJSONParser
	Dim Map1 As Map
	Map1.Initialize
	Map1.clear
	Try
		If strJSON.length > 0 Then
			json.Initialize(strJSON)
			Map1 = json.NextObject
		End If
		Return Map1
	Catch
		Return Map1
	End Try
End Sub

' convert a json string to a list
Sub Json2List(strValue As String) As List
	Dim lst As List
	lst.Initialize
	lst.clear
	If strValue.Length = 0 Then
		Return lst
	End If
	Try
		Dim parser As BANanoJSONParser
		parser.Initialize(strValue)
		Return parser.NextArray
	Catch
		Return lst
	End Try
End Sub

Sub loginw(e As BANanoEvent)
	Dim strUser As String = banano.GetElement("#txtusername").GetValue
	Dim strPwd As String = banano.GetElement("#txtpassword").GetValue
	'build php query
	Dim straction As String = "validateuser"
	Dim dbAction As Map
	dbAction.Initialize
	dbAction.Put("action=", straction)
	dbAction.Put("username=", strUser)
	dbAction.Put("userpassword=", strPwd)
	'build the php
	Dim m As Map = BuildPHP(dbAction,"users.php")
	Dim headers As Map = m.Get("headers")
	Dim sCommand As String = m.Get("command")
	Dim result As String = banano.CallAjaxWait(sCommand, "GET", "json","",False, headers)
	Log(result)
End Sub

'build the php to execute it returns a map with headers and command keys to pass to CallAjaxWait
Sub BuildPHP(pQuery As Map, phpFile As String) As Map
	Dim json As String
	Dim sCommand As String = ""
	json = Map2QueryString(pQuery)
	If Len(json) = 0 Then
		sCommand = $"${PhpPath}${phpFile}"$
	Else
		sCommand = $"${PhpPath}${phpFile}?${json}"$
	End If
	'create the headers
	Dim headers As Map
	headers.Initialize
	headers.put("Content-Type", "application/json")
	headers.Put("Access-Control-Allow-Origin", "*")
	'create map things
	Dim m As Map = CreateMap("headers":headers,"command":sCommand)
	Return m
End Sub


'get the length of the string
Sub Len(Text As String) As Int
	Return Text.Length
End Sub

'convert a map to a querystring
Sub Map2QueryString(sm As Map) As String
	' convert a map to a querystring string
	Dim iCnt As Int
	Dim iTot As Int
	Dim sb As StringBuilder
	Dim mValue As String
	sb.Initialize
	
	' get size of map
	iTot = sm.Size - 1
	iCnt = 0
	For Each mKey As String In sm.Keys
		mValue = sm.Getdefault(mKey,"")
		mValue = mValue.trim
		mValue = banano.EncodeURI(mValue)
		mKey = mKey.Trim
		If mKey.EndsWith("=") = False Then mKey = mKey & "="
		sb.Append(mKey).Append(mValue)
		If iCnt < iTot Then sb.Append("&")
		iCnt = iCnt + 1
	Next
	Return sb.ToString
End Sub

'register the user
Sub RegisterUser
	Dim strUser As String = banano.GetElement("#txtusername").GetValue
	Dim strPwd As String = banano.GetElement("#txtpassword").GetValue
	strUser = strUser.Trim
	strPwd = strPwd.trim
	Dim straction As String = "registeruser"
	Dim dbAction As Map
	dbAction.Initialize
	dbAction.Put("action=", straction)
	dbAction.Put("username=", strUser)
	dbAction.Put("userpassword=", strPwd)
	ExecutePHP(dbAction, "users.php", "registeruser")
End Sub